//+------------------------------------------------------------------+
//|                                                       Matrix.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <Indicators\TimeSeries.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>
#include "Include\IncGUI_v2.mqh"
 #include <Trade\Trade.mqh>
  #include <Trade\OrderInfo.mqh>
  #include <Trade\DealInfo.mqh>
  #include <Arrays\ArrayLong.mqh>
  #include <Arrays\ArrayDouble.mqh>
//--- input parameters
input string  S1="EURUSD";
input string  S2="USDCHF";
input string  S3="GBPUSD";
input string  S4="EURGBP";
input int      razmer=5;
input int      volantilnost=3;
input double   Lots=1.0;
input double   STARTBALANS=100000;
input double   PRP=5.0;
input datetime InpStartDate=D'2012.01.01'; // Start date

CiHigh myHigh;
CiLow myLow;
CWorkPiece hp;
CGraphicObjectShell OB;
CTrade myTrade;
COrderInfo myORD;
CDealInfo  myDeal;
CArrayLong  MAGIKB;
CArrayLong  MAGIKS;
CArrayDouble NETBUF;
CArrayLong  MAGIKBS2;
CArrayLong  MAGIKSS2;
CArrayDouble NETBUFS2;
CArrayLong  MAGIKBS3;
CArrayLong  MAGIKSS3;
CArrayDouble NETBUFS3;
CArrayLong  MAGIKBS4;
CArrayLong  MAGIKSS4;
CArrayDouble NETBUFS4;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
 int res=CheckLoadHistory(_Symbol,Period(),InpStartDate);
  res=CheckLoadHistory(S2,Period(),InpStartDate);
  res=CheckLoadHistory(S3,Period(),InpStartDate);
  res=CheckLoadHistory(S4,Period(),InpStartDate);
 hp.Label("VOL",0,50,50," - "+DoubleToString(Volantilnost(_Symbol)/_Point,0),6908200,10,"Arial");
 hp.Redraw();
//---

for (int i=0;i<razmer;i++){
NETBUF.Add(0.0);
MAGIKB.Add(2000+i);
MAGIKS.Add(3000+i);
}
for (int i=0;i<razmer;i++){
NETBUFS2.Add(0.0);
MAGIKBS2.Add(4000+i);
MAGIKSS2.Add(5000+i);
}
for (int i=0;i<razmer;i++){
NETBUFS3.Add(0.0);
MAGIKBS3.Add(6000+i);
MAGIKSS3.Add(7000+i);
}
for (int i=0;i<razmer;i++){
NETBUFS4.Add(0.0);
MAGIKBS4.Add(8000+i);
MAGIKSS4.Add(9000+i);
}

CreateNET(S1);
CreateNET(S2);
CreateNET(S3);
CreateNET(S4);

ObjectCreate(0,"Line",OBJ_HLINE,0,TimeCurrent(),StartLine(_Symbol));
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
OB.Anchor("VOL");
OB.SetText("VOL"," - "+DoubleToString(Volantilnost(_Symbol)/_Point,0));
hp.Redraw();
double BidS1=SymbolInfoDouble(S1,SYMBOL_BID);
double AskS1=SymbolInfoDouble(S1,SYMBOL_ASK);
if (NETBUF.At(NETBUF.Minimum(0,razmer))>AskS1 || NETBUF.At(NETBUF.Maximum(0,razmer))<BidS1){
DeleteNET(S1);
CreateNET(S1);}
double BidS2=SymbolInfoDouble(S2,SYMBOL_BID);
double AskS2=SymbolInfoDouble(S2,SYMBOL_ASK);
if (NETBUFS2.At(NETBUFS2.Minimum(0,razmer))>AskS2 || NETBUFS2.At(NETBUFS2.Maximum(0,razmer))<BidS2){
DeleteNET(S2);
CreateNET(S2);}
double BidS3=SymbolInfoDouble(S3,SYMBOL_BID);
double AskS3=SymbolInfoDouble(S3,SYMBOL_ASK);
if (NETBUFS3.At(NETBUFS3.Minimum(0,razmer))>AskS3 || NETBUFS3.At(NETBUFS3.Maximum(0,razmer))<BidS3){
DeleteNET(S3);
CreateNET(S3);}
double BidS4=SymbolInfoDouble(S4,SYMBOL_BID);
double AskS4=SymbolInfoDouble(S4,SYMBOL_ASK);
if (NETBUFS4.At(NETBUFS4.Minimum(0,razmer))>AskS4 || NETBUFS4.At(NETBUFS4.Maximum(0,razmer))<BidS4){
DeleteNET(S4);
CreateNET(S4);}

double PROFIT=AccountInfoDouble(ACCOUNT_PROFIT);
if (PROFIT>STARTBALANS/100*PRP){

DeleteNET(S1);
DeleteNET(S2);
DeleteNET(S3);
DeleteNET(S4);
CloseALL();
CreateNET(S2);
CreateNET(S1);
CreateNET(S3);
CreateNET(S4);

}


RepairNET(S2);
RepairNET(S1);
RepairNET(S3);
RepairNET(S4);

}
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
void CloseALL()
  {
   for(int n=0;n<1;)
     {
      for(int i=0;i<4;i++)
        {
        if (GETSYMBOL(i)==NULL){continue;}
         myTrade.PositionClose(GETSYMBOL(i),-1);
        }
      if(PositionsTotal()<1){n++;}
     }
  }
void CreateNET(string SYM){
double Bid=SymbolInfoDouble(SYM,SYMBOL_BID);
double STL=StartLine(SYM);
double STEP=Volantilnost(SYM)/razmer;
double UPLINE=Bid+(Volantilnost(SYM)/2);
int DIGS=SymbolInfoInteger(SYM,SYMBOL_DIGITS);
UPLINE=NormalizeDouble(UPLINE,DIGS);

double PR=UPLINE;
for (int i=0;i<razmer;i++)
{
if (SYM==S1){NETBUF.Update(i,PR);}
if (SYM==S2){NETBUFS2.Update(i,PR);}
if (SYM==S3){NETBUFS3.Update(i,PR);}
if (SYM==S4){NETBUFS4.Update(i,PR);}
PR=PR-STEP;
}
}

void RepairNET(string SYM){
double Bid=SymbolInfoDouble(SYM,SYMBOL_BID);
double Ask=SymbolInfoDouble(SYM,SYMBOL_ASK);
double PR=0;
long MAGICB=0;
long MAGICS=0;
double LOTB=0;
double LOTS=0;
double MA50[];
int h2=iMA(SYM,0,50,0,MODE_SMA,PRICE_CLOSE);
for (int i=0;i<100;i++){
 if(CopyBuffer(h2,0,0,2,MA50)>0){break;}
  
 Sleep(60);
 }
 double MAS50=MA50[0];
for (int i=0;i<razmer;i++){
if(SYM==S1){PR=NETBUF.At(i);
MAGICB=MAGIKB.At(i);
MAGICS=MAGIKS.At(i);
}
if(SYM==S2){PR=NETBUFS2.At(i);
MAGICB=MAGIKBS2.At(i);
MAGICS=MAGIKSS2.At(i);
}
if(SYM==S3){PR=NETBUFS3.At(i);
MAGICB=MAGIKBS3.At(i);
MAGICS=MAGIKSS3.At(i);
}
if(SYM==S4){PR=NETBUFS4.At(i);
MAGICB=MAGIKBS4.At(i);
MAGICS=MAGIKSS4.At(i);
}
if (StartLine(SYM)>MAS50){
LOTS=Lots*2;
LOTB=Lots;
}
if (StartLine(SYM)<MAS50){
LOTS=Lots;
LOTB=Lots*2;
}

if (PR>Ask){
if (!IsOrder(MAGICB,SYM)){
myTrade.SetExpertMagicNumber(MAGICB);
myTrade.BuyStop(LOTB,PR,SYM,0,0,0,0,NULL);
}
if (!IsOrder(MAGICS,SYM)){
myTrade.SetExpertMagicNumber(MAGICS);
myTrade.SellLimit(LOTS,PR,SYM,0,0,0,0,NULL);

}}

if (PR<Bid){
if (!IsOrder(MAGICB,SYM)){
myTrade.SetExpertMagicNumber(MAGICB);
myTrade.BuyLimit(LOTB,PR,SYM,0,0,0,0,NULL);
}
if (!IsOrder(MAGICS,SYM)){
myTrade.SetExpertMagicNumber(MAGICS);
myTrade.SellStop(LOTS,PR,SYM,0,0,0,0,NULL);
}

}


}
}

void DeleteNET(string SYM){
for (int i=0;i<OrdersTotal();i++){
if (OrderSelect(OrderGetTicket(i))){
if (myORD.Symbol()==SYM){
myTrade.OrderDelete(OrderGetTicket(i));}

}
}

}

bool IsOrder(long magik,string SYM){
bool IS=false;
long MN=0;
int i;
for (i=0;i<OrdersTotal();i++){
if (OrderSelect(OrderGetTicket(i))){
if (OrderGetInteger(ORDER_MAGIC)==magik){IS=true;}
}}




return(IS);
}



double StartLine(string SYM){
ENUM_TIMEFRAMES PERIOD=PERIOD_D1;
double VOL=0;
double HBUF[];
double LBUF[];
myHigh.Create(SYM,PERIOD);
myLow.Create(SYM,PERIOD);
myHigh.GetData(0,volantilnost,HBUF);
myLow.GetData(0,volantilnost,LBUF);
for (int i=1;i<volantilnost;i++){
VOL=((HBUF[i]+LBUF[i])+VOL)/i;
}
double MA50[];
int h2=iMA(SYM,0,80,0,MODE_SMA,PRICE_CLOSE);
for (int i=0;i<100;i++){
 if(CopyBuffer(h2,0,0,2,MA50)>0){break;}
  
 Sleep(60);
 }
 double MAS50=MA50[0];
 VOL=(VOL+MAS50)/2;
 ObjectSetDouble(0,"Line",OBJPROP_PRICE,VOL);
return(VOL);
}

double Volantilnost(string SYM){
ENUM_TIMEFRAMES PERIOD=PERIOD_D1;
double VOL=0;
double HBUF[];
double LBUF[];
myHigh.Create(SYM,PERIOD);
myLow.Create(SYM,PERIOD);
myHigh.GetData(0,volantilnost,HBUF);
myLow.GetData(0,volantilnost,LBUF);
for (int i=1;i<volantilnost;i++){
VOL=((HBUF[i]-LBUF[i])+VOL)/i;
}
VOL=MathMax(VOL,0.0050);

return(VOL);
}

int CheckLoadHistory(string symbol,ENUM_TIMEFRAMES period,datetime start_date)
  {
   datetime first_date=0;
   datetime times[100];
//--- check symbol & period
   if(symbol==NULL || symbol=="") symbol=Symbol();
   if(period==PERIOD_CURRENT)     period=Period();
//--- check if symbol is selected in the MarketWatch
   if(!SymbolInfoInteger(symbol,SYMBOL_SELECT))
     {
      if(GetLastError()==ERR_MARKET_UNKNOWN_SYMBOL) return(-1);
      SymbolSelect(symbol,true);
     }
//--- check if data is present
   SeriesInfoInteger(symbol,period,SERIES_FIRSTDATE,first_date);
   if(first_date>0 && first_date<=start_date) return(1);
//--- don't ask for load of its own data if it is an indicator
   if(MQL5InfoInteger(MQL5_PROGRAM_TYPE)==PROGRAM_INDICATOR && Period()==period && Symbol()==symbol)
      return(-4);
//--- second attempt
   if(SeriesInfoInteger(symbol,PERIOD_M1,SERIES_TERMINAL_FIRSTDATE,first_date))
     {
      //--- there is loaded data to build timeseries
      if(first_date>0)
        {
         //--- force timeseries build
         CopyTime(symbol,period,first_date+PeriodSeconds(period),1,times);
         //--- check date
         if(SeriesInfoInteger(symbol,period,SERIES_FIRSTDATE,first_date))
            if(first_date>0 && first_date<=start_date) return(2);
        }
     }
//--- max bars in chart from terminal options
   int max_bars=TerminalInfoInteger(TERMINAL_MAXBARS);
//--- load symbol history info
   datetime first_server_date=0;
   while(!SeriesInfoInteger(symbol,PERIOD_M1,SERIES_SERVER_FIRSTDATE,first_server_date) && !IsStopped())
      Sleep(5);
//--- fix start date for loading
   if(first_server_date>start_date) start_date=first_server_date;
   if(first_date>0 && first_date<first_server_date)
      Print("Warning: first server date ",first_server_date," for ",symbol,
            " does not match to first series date ",first_date);
//--- load data step by step
   int fail_cnt=0;
   while(!IsStopped())
     {
      //--- wait for timeseries build
      while(!SeriesInfoInteger(symbol,period,SERIES_SYNCHRONIZED) && !IsStopped())
         Sleep(5);
      //--- ask for built bars
      int bars=Bars(symbol,period);
      if(bars>0)
        {
         if(bars>=max_bars) return(-2);
         //--- ask for first date
         if(SeriesInfoInteger(symbol,period,SERIES_FIRSTDATE,first_date))
            if(first_date>0 && first_date<=start_date) return(0);
        }
      //--- copying of next part forces data loading
      int copied=CopyTime(symbol,period,bars,100,times);
      if(copied>0)
        {
         //--- check for data
         if(times[0]<=start_date)  return(0);
         if(bars+copied>=max_bars) return(-2);
         fail_cnt=0;
        }
      else
        {
         //--- no more than 100 failed attempts
         fail_cnt++;
         if(fail_cnt>=100) return(-5);
         Sleep(10);
        }
     }
//--- stopped
   return(-3);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
string GetPeriodName(ENUM_TIMEFRAMES period)
  {
   if(period==PERIOD_CURRENT) period=Period();
//---
   switch(period)
     {
      case PERIOD_M1:  return("M1");
      case PERIOD_M2:  return("M2");
      case PERIOD_M3:  return("M3");
      case PERIOD_M4:  return("M4");
      case PERIOD_M5:  return("M5");
      case PERIOD_M6:  return("M6");
      case PERIOD_M10: return("M10");
      case PERIOD_M12: return("M12");
      case PERIOD_M15: return("M15");
      case PERIOD_M20: return("M20");
      case PERIOD_M30: return("M30");
      case PERIOD_H1:  return("H1");
      case PERIOD_H2:  return("H2");
      case PERIOD_H3:  return("H3");
      case PERIOD_H4:  return("H4");
      case PERIOD_H6:  return("H6");
      case PERIOD_H8:  return("H8");
      case PERIOD_H12: return("H12");
      case PERIOD_D1:  return("Daily");
      case PERIOD_W1:  return("Weekly");
      case PERIOD_MN1: return("Monthly");
     }
//---
   return("unknown period");
  }
  string GETSYMBOL(int N)
  {

   switch(N)
     {
      case 0:  return(S1);
      case 1:  return(S2);
      case 2:  return(S3);
      case 3:  return(S4);
     
     }
   return("ERROR");
  }